package dk.nsp.idsas.dao.entity;

import java.time.Instant;
import java.util.Objects;

public class BlurringEntity {
    private String patientIdHash;
    private String patientIdType;
    private String organisationId;
    private String organisationIdType;
    private Instant expiryDate;

    public BlurringEntity() {
    }

    public BlurringEntity(String patientIdHash, String patientIdType, String organisationId, String organisationIdType, Instant expiryDate) {
        this.patientIdHash = patientIdHash;
        this.patientIdType = patientIdType;
        this.organisationId = organisationId;
        this.organisationIdType = organisationIdType;
        this.expiryDate = expiryDate;
    }

    public String getPatientIdHash() {
        return patientIdHash;
    }

    public void setPatientIdHash(String patientIdHash) {
        this.patientIdHash = patientIdHash;
    }

    public String getPatientIdType() {
        return patientIdType;
    }

    public void setPatientIdType(String patientIdType) {
        this.patientIdType = patientIdType;
    }

    public String getOrganisationId() {
        return organisationId;
    }

    public void setOrganisationId(String organisationId) {
        this.organisationId = organisationId;
    }

    public String getOrganisationIdType() {
        return organisationIdType;
    }

    public void setOrganisationIdType(String organisationIdType) {
        this.organisationIdType = organisationIdType;
    }

    public Instant getExpiryDate() {
        return expiryDate;
    }

    public void setExpiryDate(Instant expiryDate) {
        this.expiryDate = expiryDate;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        BlurringEntity that = (BlurringEntity) o;
        return Objects.equals(patientIdHash, that.patientIdHash) && Objects.equals(patientIdType, that.patientIdType) && Objects.equals(organisationId, that.organisationId) && Objects.equals(organisationIdType, that.organisationIdType) && Objects.equals(expiryDate, that.expiryDate);
    }

    @Override
    public int hashCode() {
        return Objects.hash(patientIdHash, patientIdType, organisationId, organisationIdType, expiryDate);
    }
}
