package dk.nsp.idsas.security;

public class IdsasActor {
    private final IdsasActorType actorType;
    private final String organizationId;
    private final String organizationIdType;
    private final String clientSystemName;
    private final String clientKey;

    private IdsasActor(IdsasActorType actorType, String organizationId, String organizationIdType, String clientSystemName, String clientKey) {
        this.actorType = actorType;
        this.organizationIdType = organizationIdType;
        this.organizationId = organizationId;
        this.clientSystemName = clientSystemName;
        this.clientKey = clientKey;
    }

    public static IdsasActor createSundhedsFaglig(String organizationId, String organizationIdType) {
        return new IdsasActor(IdsasActorType.SUNDHEDSFAGLIG, organizationId, organizationIdType, "", "");
    }

    public static IdsasActor createSystem(String organizationId, String organizationIdType, String clientSystemName, String clientKey) {
        return new IdsasActor(IdsasActorType.SYSTEM, organizationId, organizationIdType, clientSystemName, clientKey);
    }

    public IdsasActorType getActorType() {
        return actorType;
    }

    public String getOrganizationId() {
        return organizationId;
    }

    public String getClientSystemName() {
        return clientSystemName;
    }

    public String getClientKey() {
        return clientKey;
    }

    public String getOrganizationIdType() {
        return organizationIdType;
    }

    public enum IdsasActorType {
        SUNDHEDSFAGLIG("Sundhedsfaglig"),
        SYSTEM("System");
        private final String actorType;
        IdsasActorType(String actorType) {
            this.actorType = actorType;
        }
        public String getDisplayableText() {
            return actorType;
        }
    }
}
