package dk.nsp.idsas.util;

public class ErrorMessages {
    public static String cvrWhitelistError(String cvr, WhitelistType whitelistType) {
        return String.format("CVR '%s' er ikke whitelisted for type %s", cvr, whitelistType);
    }

    public static String clientKeyWhitelistError(String cvr, WhitelistType whitelistType) {
        return String.format("Client persistent unique key '%s' er ikke whitelisted for type %s", cvr, whitelistType);
    }

    public static String cprIsNotValidError(String cpr) {
        return String.format("CPR '%s' er ikke tilknyttet en borger", cpr);
    }

    public static String invalidUserType(String causes) {
        return String.format("Brugertypen kunne ikke bestemmes ud fra den medsendte sikkerhedsbillet. Årsager: %s", causes);
    }

    public static String actorValidationError(String type, String msg) {
        return String.format("Brugertypen %s kunne ikke valideres: %s", type, msg);
    }

    public static String userTypeAmbiguous(String typer) {
        return String.format("Brugertypen kunne ikke entydigt bestemmes ud fra den medsendte sikkerhedsbillet. Matchede typer: %s", typer);
    }

    public static String userTypeNotSupported(String userType) {
        return String.format("Brugertypen '%s' er ikke understøttet", userType);
    }

    public static String clientSystemNameError(String givenName, String expectedName) {
        return String.format("Systembruger med clientName \"%s\" matcher ikke nogen af de forventede navne: %s",
                givenName, expectedName);
    }

    public static String noSaltError() {
        return "Ingen salt var fundet.";
    }

    public static String maxExpiryDateExceeded(int dage) {
        return String.format("Slutdatoen for en sløring må ikke ligge mere end %s dage fremme i tiden.", dage);
    }

    public static String ticketIsExpiredError() {
        return "Sikkerhedsbilletten er udløbet";
    }

    public static String ticketIsNotYetValidError() {
        return "Sikkerhedsbilletten er ikke gyldig endnu";
    }

    public static String ticketIsNotValidError(String audience, String created) {
        return String.format("Sikkerhedsbilletten er ikke valid. audience = \"%S\", created = %s", audience, created);
    }

    public static String ticketIsMissing() {
        return "Sikkerhedsbilletten mangler";
    }

    public static String organizationIdTypeNotSupported(String organizationIdType) {
        return String.format("Organisation ID typen '%s' er ikke understøttet", organizationIdType);
    }

    public static String daoAccessError() {
        return "Der opstod en fejl ved adgang til databasen";
    }

    public static String orgBlurringAlreadyExists() {
        return "Der findes allerede en aktiv afdelingssløring for den pågældende organisation";
    }

    public static String sorDoesNotExist() {
        return "SOR-koden findes ikke";
    }

    public static String sorClientError() {
        return "Der opstod en fejl ved kald til SORES";
    }

    public static String orgBlurringDoesNotExist() {
        return "Der findes ikke en aktiv afdelingssløring for den pågældende organisation";
    }

    public static String orgBlurringNotCreatedByOrg() {
        return "Den pågældende afdelingssløring er ikke oprettet af den pågældende organisation";
    }

    public static String sorDoesNotBelongToCvr(String sor, String cvr) {
        return String.format("SOR-koden '%s' hører ikke under den pågældende CVR '%s'", sor, cvr);
    }

    public static String whitelistingActorIdType(String actorIdType, String supportedIdType) {
        return String.format("Kun aktører med id type '%s' kan være whitelisted. Kalder havde id type '%s'.", supportedIdType, actorIdType);
    }

    public static String multipleOrgBlurrings() {
        return "Der findes flere aktive afdelingssløringer for den pågældende organisation";
    }
}
