package dk.nsp.idsas.util;

import dk.nsp.idsas.service.IdsasServiceException;
import org.apache.log4j.Logger;

import javax.xml.bind.DatatypeConverter;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.nio.charset.StandardCharsets;

public class HashingUtil {
    private static final Logger logger = Logger.getLogger(HashingUtil.class);

    public static String createPatientIdHash(String patientId, String saltPrefix, String saltPostfix) throws IdsasServiceException {
        try {
            MessageDigest digest = MessageDigest.getInstance("SHA-256");
            String toHash = saltPrefix + patientId + saltPostfix;
            byte[] hash = digest.digest(toHash.getBytes(StandardCharsets.UTF_8));
            return DatatypeConverter.printHexBinary(hash).toLowerCase();
        } catch (NoSuchAlgorithmException e) {
            logger.error("No such algorithm exception", e);
            throw new IdsasServiceException("Error creating hash", FaultCode.HASHING_ERROR, false, e);
        }
    }
}