package dk.nsp.idsas.util;

public abstract class IdsasException extends Exception {
    private final boolean client;
    private final FaultCode code;

    public IdsasException(String message, FaultCode code, boolean client) {
        super(message);
        this.client = client;
        this.code = code;
    }

    public IdsasException(String message, FaultCode code, boolean client, Throwable e) {
        super(message, e);
        this.client = client;
        this.code = code;
    }

    public boolean isClient() {
        return client;
    }

    public FaultCode getCode() {
        return code;
    }
}
