package dk.nsp.idsas.dao;

import dk.nsp.idsas.util.WhitelistType;
import org.junit.Before;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import javax.sql.DataSource;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

public class WhitelistDaoTest extends AbstractDaoTest {
    @Autowired
    DataSource dataSource;
    private WhitelistDao whitelistDao;

    @Before
    public void setUp() {
        whitelistDao = new WhitelistDao(dataSource);
    }

    @Test
    public void isWhitelisted_WhenActorIdIsNotWhitelisted_ReturnsFalse() {
        boolean result = whitelistDao.isWhitelisted("0000", WhitelistType.BLURRING);

        assertFalse(result);
    }

    @Test
    public void isWhitelisted_WhenActorIdIsWhitelistedForType_ReturnsTrue() {
        boolean result = whitelistDao.isWhitelisted("1234", WhitelistType.BLURRING);

        assertTrue(result);
    }
}