package dk.nsp.idsas.dao.entity;

import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotEquals;
import static org.junit.Assert.assertFalse;

import java.time.Instant;

public class BlurringEntityTest {

    @Test
    public void testEquals() {
        Instant now = Instant.now();
        BlurringEntity entity1 = new BlurringEntity("hash1", "type1", "org1", "orgType1", now);
        BlurringEntity entity2 = new BlurringEntity("hash1", "type1", "org1", "orgType1", now);
        BlurringEntity entity3 = new BlurringEntity("hash2", "type2", "org2", "orgType2", now);

        // Test equal entities
        assertEquals(entity1, entity2);

        // Test not equal entities
        assertNotEquals(entity1, entity3);

        // Test equality when 'o' and 'this' are the same
        assertEquals(entity1, entity1);

        // Test equality when 'o' is null
        assertFalse(entity1.equals(null));

        // Test equality when 'o' is of a different class
        assertFalse(entity1.equals("string"));
    }

    @Test
    public void testHashCode() {
        Instant now = Instant.now();
        BlurringEntity entity1 = new BlurringEntity("hash1", "type1", "org1", "orgType1", now);
        BlurringEntity entity2 = new BlurringEntity("hash1", "type1", "org1", "orgType1", now);

        assertEquals(entity1.hashCode(), entity2.hashCode());
    }
}
