package dk.nsp.idsas.dao.entity;

import org.junit.Test;

import static org.junit.Assert.*;

public class OrgBlurringEntityTest {
    @Test
    public void testEquals() {
        OrgBlurringEntity entity1 = new OrgBlurringEntity("org1", "type1", "cvr1", null, null);
        OrgBlurringEntity entity2 = new OrgBlurringEntity("org1", "type1", "cvr1", null, null);
        OrgBlurringEntity entity3 = new OrgBlurringEntity("org2", "type2", "cvr2", null, null);

        // Test equal entities
        assertEquals(entity1, entity2);

        // Test not equal entities
        assertNotEquals(entity1, entity3);

        // Test equality when 'o' and 'this' are the same
        assertEquals(entity1, entity1);

        // Test equality when 'o' is null
        assertFalse(entity1.equals(null));

        // Test equality when 'o' is of a different class
        assertFalse(entity1.equals("string"));
    }

    @Test
    public void testHashCode() {
        OrgBlurringEntity entity1 = new OrgBlurringEntity("org1", "type1", "cvr1", null, null);
        OrgBlurringEntity entity2 = new OrgBlurringEntity("org1", "type1", "cvr1", null, null);

        assertEquals(entity1.hashCode(), entity2.hashCode());
    }


}
