package dk.nsp.idsas.util;

import javax.xml.ws.soap.SOAPFaultException;

import org.junit.Test;

import static dk.nsp.idsas.util.SoapFaultGenerator.*;
import static org.junit.Assert.assertTrue;

public class SoapFaultGeneratorTest {

    @Test
    public void exceptionContainsMessage() {
        // Arrange and act
        SOAPFaultException e = generateSOAPFault(true, "test", "error-code");

        // Assert
        assertTrue(e.getMessage().contains("test"));
    }

    @Test
    public void exceptionContainsClientValue() {
        // Arrange and act
        SOAPFaultException eFalse = generateSOAPFault(false, "test", "error-code");
        SOAPFaultException eTrue = generateSOAPFault(true, "test", "error-code");

        // Assert
        assertTrue(eFalse.getFault().getFaultCode().contains("Server"));
        assertTrue(eTrue.getFault().getFaultCode().contains("Client"));
    }

}