package dk.nsp.idsas.test._20230601;

import dk.nsp.idsas.test.util.HttpClient;
import io.cucumber.java.en.And;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.springframework.beans.factory.annotation.Value;

import javax.annotation.PostConstruct;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

public class DksServletStepDefinitions {
    @Value("${idsas.registration.endpoint}" + "/20230601/dksconfig")
    private String registrationEndpoint;

    @Value("${idsas.lookup.endpoint}" + "/20230601/dksconfig")
    private String lookupEndpoint;

    @Value("${idsas.salt.endpoint}" + "/dksconfig")
    private String saltEndpoint;

    private Map<String, String> endpoints = new HashMap<>();
    private int responseCode;
    private String responseBody;

    @PostConstruct
    public void init() {
        endpoints.put("idsas-registration", registrationEndpoint);
        endpoints.put("idsas-lookup", lookupEndpoint);
        endpoints.put("idsas-salt", saltEndpoint);
    }

    @When("svar hentes fra {string} dksServlet")
    public void svarHentesFraDksServlet(String service) throws IOException {
        String endpoint = endpoints.get(service);
        HttpClient httpClient = new HttpClient();
        responseBody = httpClient.get(endpoint);
        responseCode = httpClient.getResponseCode();
    }

    @Then("Returneres http kode {int} fra dksServlet")
    public void validateResponseCode(int expectedResponseCode) {
        assertEquals(expectedResponseCode, responseCode);
    }

    @And("Svaret fra dksServlet indeholder relevante oplysninger")
    public void svaretIndeholderRelevanteOplysninger() {
        assertTrue(responseBody.contains("<dksVersion>"));
        assertTrue(responseBody.contains("<operations>"));
        assertTrue(responseBody.contains("<action "));
        assertTrue(responseBody.contains("sundhedsdatastyrelsen"));
    }
}
