package dk.nsp.idsas.test.idptest;

public enum SOAPOperation {
    CreateBlurring2023(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/#CreateBlurring",
            "CreateBlurringRequest"),

    GetBlurredOrganisations2023(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/#GetBlurredOrganisations",
            "GetBlurredOrganisationsRequest"),

    GetCurrentSalt(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/#GetCurrentSalt"
    ),

    CreateBlurring(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2024/01/24/#CreateBlurring"
    ),

    GetBlurredOrganisations(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2024/01/24/#GetBlurredOrganisations"
    ),

    CreateOrgBlurring(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2024/01/24/#CreateOrgBlurring"
    ),

    RemoveOrgBlurring(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2024/01/24/#RemoveOrgBlurring"
    ),

    ListAllActiveOrgBlurrings(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2024/01/24/#ListAllActiveOrgBlurrings"
    ),

    ListOrgBlurringsForCVR(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2024/01/24/#ListOrgBlurringsForCVR"
    );

    private String soapNamespace = "";
    private final String soapOperation;
    private String rootElement;

    @Deprecated // Only use this for 2023 operations
    SOAPOperation(String soapNamespace, String soapOperation, String rootElement) {
        this.soapNamespace = soapNamespace;
        this.soapOperation = soapOperation;
        this.rootElement = rootElement;
    }

    SOAPOperation(String soapOperation) {
        this.soapOperation = soapOperation;
    }

    public String getSoapNamespace() {
        return soapNamespace;
    }

    public String getSoapOperation() {
        return soapOperation;
    }

    public String getRootElement() {
        return rootElement;
    }
}