package dk.nsp.idsas.test.util;

import dk.nsp.test.idp.CitizenIdentities;
import dk.nsp.test.idp.EmployeeIdentities;
import dk.nsp.test.idp.OrganizationIdentities;
import dk.nsp.test.idp.builder.Builders;
import dk.nsp.test.idp.model.Identity;
import dk.nsp.test.idp.vault.RemoteCredentialVault;

import java.net.URI;

import static dk.nsp.test.idp.builder.Builders.*;

public class TestIdentities {
    public static Identity identityFor(String userType) {
        switch (userType) {
            case "borger":
                return CitizenIdentities.adaLovelace("https://fmk");
            case "sundhedsfaglig":
                return EmployeeIdentities.lægeCharlesBabbage();
            case "systembruger":
                return OrganizationIdentities.sundhedsdatastyrelsen();
            case "en-anden-systembruger":
                return OrganizationIdentities.testOrganisation98021838();
            default:
                throw new RuntimeException("Unknown user type " + userType);
        }
    }

    public static Identity systembrugerMedClientName(String clientName) {
        return Builders.organizationIdentity()
                .representing(organization()
                        .named("Test organisation 98021838")
                        .identifiedBy("98021838"))
                .usedBy(serviceConsumer()
                        .named(clientName)
                        .identifiedBy(new RemoteCredentialVault(URI.create("https://www.nspop.dk/download/attachments/190481050/NSP_Test_Service_Consumer_testorg.p12"), "Test1234".toCharArray(), true)))
                .using(securityTokenService()
                        .at(URI.create("http://test1.ekstern-test.nspop.dk:8080/sts/services/NewSecurityTokenService")))
                .build();
    }
}
