package dk.nsp.idsas.ws;

import static org.mockito.Mockito.*;
import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;
import java.io.StringWriter;

public class AbstractHealthServletTest {

    @InjectMocks
    private AbstractHealthServlet servlet = new AbstractHealthServlet() {};

    @Mock
    private HttpServletRequest request;

    @Mock
    private HttpServletResponse response;

    @Before
    public void setUp() {
        MockitoAnnotations.openMocks(this);
    }

    @Test
    public void doGet() throws Exception {
        StringWriter stringWriter = new StringWriter();
        PrintWriter writer = new PrintWriter(stringWriter);

        when(response.getWriter()).thenReturn(writer);

        servlet.doGet(request, response);

        verify(response).setHeader("Content-Type", "application/json; charset=UTF-8");
        verify(response).setCharacterEncoding("UTF-8");
        verify(response).setStatus(anyInt());
        assertFalse(stringWriter.toString().isEmpty());
    }
}
