package dk.nsp.idsas.ws;

import dk.nsp.idsas.ws._20230601.IdsasLookupDksServlet;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.net.URL;

import static org.mockito.Mockito.*;

public class IdsasLookupDksServletTest {

    @Mock
    private HttpServletRequest request;

    @Mock
    private HttpServletResponse response;

    @Mock
    private PrintWriter writer;

    private IdsasLookupDksServlet servlet;

    @Before
    public void setUp() throws IOException {
        MockitoAnnotations.openMocks(this);
        servlet = new IdsasLookupDksServlet() {

            {
                this.dccEndpoint = "";
            }

            @Override
            protected URL getResource() {
                try {
                    return new URL("file:///tmp/fgvhr-citizen.xml");
                } catch (MalformedURLException e) {
                    throw new RuntimeException(e);
                }
            }

            @Override
            protected InputStream getResourceAsStream() {
                return new ByteArrayInputStream("TIMESTAMP ENDPOINT_PLACEHOLDER".getBytes());
            }

        };

        when(response.getWriter()).thenReturn(writer);
    }

    @Test
    public void testDoGet() throws IOException {
        // Act
        servlet.doGet(request, response);

        // Assert
        verify(response).setContentType("application/xml");
        verify(response).setStatus(200);
        verify(response).addHeader("Cache-Control", "no-cache");
        verify(writer).print(anyString()); // Check that some response is written
    }
}
