package dk.nsp.idsas.operations.ws;

import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import dk.nsp.idsas.service.CleanupService;
import dk.nsp.idsas.ws.AbstractServlet;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.time.OffsetDateTime;
import java.time.format.DateTimeFormatter;

@WebServlet(name="CleanUpServlet", urlPatterns={"/cleanup-blurrings"})
public class CleanUpServlet extends AbstractServlet {
    private static final Logger logger = Logger.getLogger(CleanUpServlet.class);

    @Autowired
    private CleanupService cleanupService;

    @Override
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        logger.trace("Enter cleanup blurrings");

        cleanupService.cleanUpBlurrings();

        response.setStatus(HttpServletResponse.SC_OK);
        response.getOutputStream().write(DateTimeFormatter.ISO_OFFSET_DATE_TIME.format(
                OffsetDateTime.now()).getBytes(StandardCharsets.UTF_8));
    }

}
