package dk.nsp.idsas.operations.ws;

import dk.nsp.idsas.service.SaltService;
import dk.nsp.idsas.ws.AbstractServlet;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;

import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.time.OffsetDateTime;
import java.time.format.DateTimeFormatter;

@WebServlet(name="RenewSaltServlet", urlPatterns={"/renew-salt"})
public class RenewSaltServlet extends AbstractServlet {
    private static final Logger logger = Logger.getLogger(RenewSaltServlet.class);

    @Autowired
    private SaltService saltService;

    @Override
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        logger.trace("Enter renew salt");

        saltService.renewSalt();

        response.setStatus(HttpServletResponse.SC_OK);
        response.getOutputStream().write(DateTimeFormatter.ISO_OFFSET_DATE_TIME.format(
                OffsetDateTime.now()).getBytes(StandardCharsets.UTF_8));
    }

}
