package dk.nsp.idsas.operations.ws;

import dk.nsp.idsas.service.SaltService;
import org.junit.Before;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.io.IOException;

import static org.mockito.Mockito.*;

public class RenewSaltServletTest {

    @Mock
    private SaltService saltService;

    @Mock
    private HttpServletRequest request;

    @Mock
    private HttpServletResponse response;

    @Mock
    private ServletOutputStream servletOutputStream;

    @InjectMocks
    private RenewSaltServlet renewSaltServlet;

    @Before
    public void setUp() throws IOException {
        MockitoAnnotations.openMocks(this);
        when(response.getOutputStream()).thenReturn(servletOutputStream);
    }

    @Test
    public void testDoGet() throws IOException {
        renewSaltServlet.doGet(request, response);

        verify(saltService).renewSalt();
        verify(response).setStatus(200);
        verify(servletOutputStream).write(any(byte[].class));
    }
}