package dk.nsp.idsas.http;

import org.apache.http.client.HttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.impl.conn.PoolingHttpClientConnectionManager;

public class PoolingHttpClientFactory {

	private final HttpClient client;

    public PoolingHttpClientFactory(int maxTotalConnections, int defaultMaxConnectionsPerRoute) {
        PoolingHttpClientConnectionManager cm = new PoolingHttpClientConnectionManager();
        cm.setMaxTotal(maxTotalConnections);
        cm.setDefaultMaxPerRoute(defaultMaxConnectionsPerRoute);
        client = HttpClients.custom().setConnectionManager(cm).build();
    }

    public HttpClient getClient() {
        return client;
    }
}
